## casablanca 2.6.0

=== Release/CMakeLists.txt ===
set(CMAKE_LEGACY_CYGWIN_WIN32 0)
cmake_minimum_required(VERSION 2.6)
project(casablanca)

enable_testing()

set(WARNINGS)
set(ANDROID_STL_FLAGS)

# Platform (not compiler) specific settings
if(IOS)
  set(IOS_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../Build_iOS")
  set(Boost_FRAMEWORK "-F ${IOS_SOURCE_DIR} -framework boost")
  set(Boost_INCLUDE_DIR "${IOS_SOURCE_DIR}/boost.framework/Headers")

  set(OPENSSL_FOUND 1)
  set(OPENSSL_INCLUDE_DIR "${IOS_SOURCE_DIR}/openssl/include")
  set(OPENSSL_LIBRARIES
    "${IOS_SOURCE_DIR}/openssl/lib/libcrypto.a"
    "${IOS_SOURCE_DIR}/openssl/lib/libssl.a"
    )

  # The cxx_flags must be reset here, because the ios-cmake toolchain file unfortunately sets "-headerpad_max_install_names" which is not a valid clang flag.
  set(CMAKE_CXX_FLAGS "-fvisibility=hidden -fvisibility-inlines-hidden")

  set(BUILD_SHARED_LIBS OFF)
  set(BUILD_SAMPLES OFF)
  option(BUILD_TESTS "Build tests." ON)
elseif(ANDROID)
  set(Boost_COMPILER "-clang")
  set(Boost_USE_STATIC_LIBS ON)
  if(ARM)
    set(BOOST_ROOT "${CMAKE_BINARY_DIR}/../Boost-for-Android/build")
    set(BOOST_LIBRARYDIR "${CMAKE_BINARY_DIR}/../Boost-for-Android/build/lib")
  else()
    set(BOOST_ROOT "${CMAKE_BINARY_DIR}/../Boost-for-Android-x86/build")
    set(BOOST_LIBRARYDIR "${CMAKE_BINARY_DIR}/../Boost-for-Android-x86/build/lib")
  endif()
  find_host_package(Boost 1.55 EXACT REQUIRED COMPONENTS random system thread filesystem chrono atomic)

  set(OPENSSL_FOUND 1)
  if(ARM)
    set(OPENSSL_INCLUDE_DIR "${CMAKE_BINARY_DIR}/../openssl/armeabi-v7a/include")
    set(OPENSSL_LIBRARIES
      "${CMAKE_BINARY_DIR}/../openssl/armeabi-v7a/lib/libssl.a"
      "${CMAKE_BINARY_DIR}/../openssl/armeabi-v7a/lib/libcrypto.a"
      )
  else()
    set(OPENSSL_INCLUDE_DIR "${CMAKE_BINARY_DIR}/../openssl/x86/include")
    set(OPENSSL_LIBRARIES
      "${CMAKE_BINARY_DIR}/../openssl/x86/lib/libssl.a"
      "${CMAKE_BINARY_DIR}/../openssl/x86/lib/libcrypto.a"
      )
  endif()

  if(ARM)
    set(LIBCXX_STL "${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++/4.8/libs/armeabi-v7a/thumb/libgnustl_static.a")
  else()
    set(LIBCXX_STL "${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++/4.8/libs/x86/libgnustl_static.a")
  endif()
  # These are used in the shared library case
  set(ANDROID_STL_FLAGS
    ${LIBCXX_STL}
    atomic
    dl
    gcc
    c
    m
    -nodefaultlibs
    )

  option(BUILD_SHARED_LIBS "Build shared Libraries." OFF)
  set(BUILD_SAMPLES OFF)
  option(BUILD_TESTS "Build tests." ON)
elseif(UNIX) # This includes OSX
  find_package(Boost REQUIRED COMPONENTS random chrono system thread regex filesystem)
  find_package(Threads REQUIRED)
  if(APPLE AND NOT OPENSSL_ROOT_DIR)
    # Prefer a homebrew version of OpenSSL over the one in /usr/lib
    file(GLOB OPENSSL_ROOT_DIR /usr/local/Cellar/openssl/*)
    # Prefer the latest (make the latest one first)
    list(REVERSE OPENSSL_ROOT_DIR)
  endif()
  # This should prevent linking against the system provided 0.9.8y
  set(_OPENSSL_VERSION "")
  find_package(OpenSSL 1.0.0 REQUIRED)

  option(BUILD_SHARED_LIBS "Build shared Libraries." ON)
  option(BUILD_TESTS "Build tests." ON)
  option(BUILD_SAMPLES "Build samples." ON)
  option(CASA_INSTALL_HEADERS "Install header files." ON)
  if(CASA_INSTALL_HEADERS)
    file(GLOB CASA_HEADERS_CPPREST include/cpprest/*.hpp include/cpprest/*.h include/cpprest/*.dat)
    install(FILES ${CASA_HEADERS_CPPREST} DESTINATION include/cpprest)
    file(GLOB CASA_HEADERS_PPLX include/pplx/*.hpp include/pplx/*.h)
    install(FILES ${CASA_HEADERS_PPLX} DESTINATION include/pplx)
    file(GLOB CASA_HEADERS_DETAILS include/cpprest/details/*.hpp include/cpprest/details/*.h include/cpprest/details/*.dat)
    install(FILES ${CASA_HEADERS_DETAILS} DESTINATION include/cpprest/details)
  endif()
elseif(WIN32)
  option(BUILD_SHARED_LIBS "Build shared Libraries." ON)
  option(BUILD_TESTS "Build tests." ON)
  option(BUILD_SAMPLES "Build samples." ON)
  option(Boost_USE_STATIC_LIBS ON)

  add_definitions(-DUNICODE -D_UNICODE)

  if(NOT BUILD_SHARED_LIBS)
    # This causes cmake to not link the test libraries separately, but instead hold onto their object files.
    set(TEST_LIBRARY_TARGET_TYPE OBJECT)
    set(Casablanca_DEFINITIONS -D_NO_ASYNCRTIMP -D_NO_PPLXIMP CACHE INTERNAL "Definitions for consume casablanca library")
  else()
    set(Casablanca_DEFINITIONS "" CACHE INTERNAL "Definitions for consume casablanca library")
  endif()
  add_definitions(${Casablanca_DEFINITIONS} -D_WINSOCK_DEPRECATED_NO_WARNINGS -DWIN32)

  find_package(Boost 1.55 REQUIRED COMPONENTS random system thread filesystem chrono atomic)
  find_package(OpenSSL 1.0 REQUIRED)
else()
  message(FATAL_ERROR "-- Unsupported Build Platform.")
endif()

# Compiler (not platform) specific settings
if(ANDROID)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-strict-aliasing")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-pedantic")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-attributes -Wno-pointer-arith")
  include_directories(
    "${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++/4.8/include"
    "${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++/4.8/libs/armeabi-v7a/include"
    "${ANDROID_NDK}/sources/cxx-stl/gnu-libstdc++/4.8/include/backward"
    )
elseif((CMAKE_CXX_COMPILER_ID MATCHES "Clang") OR IOS)
  message("-- Setting clang options")

  set(WARNINGS "-Wall -Wextra -Wcast-qual -Wconversion -Wformat=2 -Winit-self -Winvalid-pch -Wmissing-format-attribute -Wmissing-include-dirs -Wpacked -Wredundant-decls")
  set(OSX_SUPPRESSIONS "-Wno-overloaded-virtual -Wno-sign-conversion -Wno-deprecated -Wno-unknown-pragmas -Wno-reorder -Wno-char-subscripts -Wno-switch -Wno-unused-parameter -Wno-unused-variable -Wno-deprecated -Wno-unused-value -Wno-unknown-warning-option -Wno-return-type-c-linkage -Wno-unused-function -Wno-sign-compare -Wno-shorten-64-to-32 -Wno-reorder")
  set(WARNINGS "${WARNINGS} ${OSX_SUPPRESSIONS}")

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++ -Wno-return-type-c-linkage -Wno-unneeded-internal-declaration")
  set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")
  set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++11")

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-strict-aliasing")
elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  message("-- Setting gcc options")

  set(WARNINGS "-Wall -Wextra -Wunused-parameter -Wcast-align -Wcast-qual -Wconversion -Wformat=2 -Winit-self -Winvalid-pch -Wmissing-format-attribute -Wmissing-include-dirs -Wpacked -Wredundant-decls -Wunreachable-code")

  set(LD_FLAGS "${LD_FLAGS} -Wl,-z,defs")

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-strict-aliasing")
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
  message("-- Setting msvc options")
  set(WARNINGS)
else()
  message("-- Unknown compiler, success is doubtful.")
  message("CMAKE_CXX_COMPILER_ID=${CMAKE_CXX_COMPILER_ID}")
endif()

# Reconfigure final output directory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/Binaries)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/Binaries)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/Binaries)

# These settings can be used by the test targets
set(Casablanca_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(Casablanca_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include ${Boost_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/libs/websocketpp)

set(Casablanca_LIBRARY ${LIB}cpprest)
set(Casablanca_LIBRARIES ${Casablanca_LIBRARY} ${Boost_LIBRARIES} ${Boost_FRAMEWORK})

# Everything in the project needs access to the casablanca include directories
include_directories(${Casablanca_INCLUDE_DIRS})

# Finally, the tests all use the same style declaration to build themselves, so we use a function
function(add_casablanca_test NAME SOURCES_VAR)
  add_library(${NAME} ${TEST_LIBRARY_TARGET_TYPE} ${${SOURCES_VAR}})
  message("-- Added test library ${NAME}")
  if (NOT TEST_LIBRARY_TARGET_TYPE STREQUAL "OBJECT")
    target_link_libraries(${NAME}
      ${LIB}httptest_utilities
      ${LIB}common_utilities
      ${LIB}unittestpp
      ${Casablanca_LIBRARIES}
      ${ANDROID_STL_FLAGS}
      )
    if (BUILD_SHARED_LIBS)
      add_test(NAME ${NAME}
        WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        COMMAND test_runner lib${NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}
        )
    endif()
  endif()
endfunction()

add_subdirectory(src)

if(BUILD_TESTS)
  add_subdirectory(tests)
endif()

if(BUILD_SAMPLES)
  add_subdirectory(samples)
endif()

=== Build_android/openssl/Makefile ===
SHELL := /bin/bash
OPENSSL_VER = openssl-1.0.1h

all: armeabi-v7a/lib/libssl.a x86/lib/libssl.a

clean:
	rm -rf $(OPENSSL_VER)
	rm -rf $(OPENSSL_VER)-armeabi-v7a
	rm -rf armeabi-v7a
	rm -rf setenv-android-x86.sh

setenv-android.sh:
	wget http://wiki.openssl.org/images/7/70/Setenv-android.sh
	mv Setenv-android.sh setenv-android.sh
	chmod a+x setenv-android.sh

setenv-android-x86.sh: setenv-android.sh
	cp setenv-android.sh setenv-android-x86.sh.tmp
	sed -i 's/_ANDROID_EABI="arm-linux-androideabi-4.8"/_ANDROID_EABI="x86-4.8"/g' setenv-android-x86.sh.tmp
	sed -i 's/_ANDROID_ARCH=arch-arm/_ANDROID_ARCH=arch-x86/g' setenv-android-x86.sh.tmp
	mv setenv-android-x86.sh.tmp setenv-android-x86.sh

$(OPENSSL_VER).tar.gz:
	wget http://www.openssl.org/source/$(OPENSSL_VER).tar.gz

armeabi-v7a/lib/libssl.a: setenv-android.sh $(OPENSSL_VER).tar.gz
	[ -d "$(ANDROID_NDK_ROOT)" ]
	export ANDROID_NDK_ROOT="$(ANDROID_NDK_ROOT)"; \
	. ./setenv-android.sh; \
	( \
		set -e; \
		rm -rf $(OPENSSL_VER)/; \
		tar xzf $(OPENSSL_VER).tar.gz; \
		rm -rf $(OPENSSL_VER)-armeabi-v7a/ \
	) && \
	mv $(OPENSSL_VER) $(OPENSSL_VER)-armeabi-v7a && \
	cd $(OPENSSL_VER)-armeabi-v7a && \
	perl -pi -e 's/install: all install_docs install_sw/install: install_docs install_sw/g' Makefile.org && \
	./config shared -no-ssl2 -no-ssl3 -no-comp -no-hw -no-engine --openssldir="`pwd`/../armeabi-v7a" && \
	make depend && \
	make all && \
	make install CC=$${ANDROID_TOOLCHAIN}/arm-linux-androideabi-gcc RANLIB=$${ANDROID_TOOLCHAIN}/arm-linux-androideabi-ranlib

x86/lib/libssl.a: setenv-android-x86.sh $(OPENSSL_VER).tar.gz
	[ -d "$(ANDROID_NDK_ROOT)" ]
	export ANDROID_NDK_ROOT="$(ANDROID_NDK_ROOT)"; \
	. ./setenv-android-x86.sh; \
	( \
		set -e; \
		rm -rf $(OPENSSL_VER)/; \
		tar xzf $(OPENSSL_VER).tar.gz; \
		rm -rf $(OPENSSL_VER)-x86/ \
	) && \
	mv $(OPENSSL_VER) $(OPENSSL_VER)-x86 && \
	cd $(OPENSSL_VER)-x86 && \
	perl -pi -e 's/install: all install_docs install_sw/install: install_docs install_sw/g' Makefile.org && \
	./config shared -no-ssl2 -no-ssl3 -no-comp -no-hw -no-engine --openssldir="`pwd`/../x86" && \
	make depend && \
	make all && \
	make install CC=$${ANDROID_TOOLCHAIN}/i686-linux-android-gcc RANLIB=$${ANDROID_TOOLCHAIN}/i686-linux-android-ranlib

=== Release/src/CMakeLists.txt ===
include_directories(../include pch ${Boost_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR})

set(SOURCES_COMMON
  http/client/http_client_msg.cpp
  http/client/x509_cert_utilities.cpp
  http/common/http_helpers.cpp
  http/common/http_msg.cpp
  http/listener/http_listener.cpp
  http/listener/http_listener_msg.cpp
  http/listener/http_server_api.cpp
  http/oauth/oauth1.cpp
  http/oauth/oauth2.cpp
  json/json.cpp
  json/json_parsing.cpp
  json/json_serialization.cpp
  pplx/pplx.cpp
  uri/uri.cpp
  uri/uri_builder.cpp
  uri/uri_parser.cpp
  utilities/asyncrt_utils.cpp
  utilities/base64.cpp
  utilities/web_utilities.cpp
  websockets/client/ws_msg.cpp
  websockets/client/ws_client.cpp
  websockets/client/ws_client_wspp.cpp
)

# THE ORDER OF FILES IS VERY /VERY/ IMPORTANT
if(UNIX)
  set(SOURCES
    ${SOURCES_COMMON}
    streams/fileio_posix.cpp
    pplx/threadpool.cpp
    http/client/http_client_asio.cpp
    http/listener/http_server_asio.cpp
  )
  if(APPLE)
    list(APPEND SOURCES
      pplx/pplxapple.cpp
      http/client/x509_cert_utilities_apple.cpp
    )
    find_library(COREFOUNDATION CoreFoundation "/")
    find_library(SECURITY Security "/")
    set(EXTRALINKS ${COREFOUNDATION} ${SECURITY})
  elseif(ANDROID)
    list(APPEND SOURCES
      http/client/x509_cert_utilities_android.cpp
      pplx/pplxlinux.cpp
    )
  else()
    list(APPEND SOURCES pplx/pplxlinux.cpp)
  endif()
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARNINGS} -Werror -pedantic")
elseif(WIN32)
  set(SOURCES
    ${SOURCES_COMMON}
    http/client/http_client_winhttp.cpp
    http/client/x509_cert_utilities_win32.cpp
    http/listener/http_server_httpsys.cpp
    pplx/pplxwin.cpp
    streams/fileio_win32.cpp
    pch/stdafx.cpp
  )
  set(EXTRALINKS
    bcrypt.lib
    crypt32.lib
    httpapi.lib
    Winhttp.lib
  )
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WARNINGS} /Yustdafx.h /Zm200")
  set_source_files_properties(pch/stdafx.cpp PROPERTIES COMPILE_FLAGS "/Ycstdafx.h")
  if (BUILD_SHARED_LIBS)
    add_definitions(-D_ASYNCRT_EXPORT -D_PPLX_EXPORT -D_USRDLL)
  endif()
endif()

add_library(${Casablanca_LIBRARY} ${SOURCES})

target_link_libraries(${Casablanca_LIBRARY}
  ${CMAKE_THREAD_LIBS_INIT}
  ${Boost_SYSTEM_LIBRARY}
  ${Boost_THREAD_LIBRARY}
  ${Boost_ATOMIC_LIBRARY}
  ${Boost_CHRONO_LIBRARY}
  ${Boost_RANDOM_LIBRARY}
  ${EXTRALINKS}
  ${Boost_FRAMEWORK}
  ${OPENSSL_LIBRARIES}
  ${COREFOUNDATION}
  ${ANDROID_STL_FLAGS}
  )

# Portions specific to cpprest binary versioning.
set (CPPREST_VERSION_MAJOR 2)
set (CPPREST_VERSION_MINOR 6)
set (CPPREST_VERSION_REVISION 0)

if(WIN32)
  set_target_properties(${Casablanca_LIBRARY} PROPERTIES
    OUTPUT_NAME "${Casablanca_LIBRARY}_${CPPREST_VERSION_MAJOR}_${CPPREST_VERSION_MINOR}")
elseif(ANDROID)
  # Do not use SOVERSION on android. It is completely unsupported (and causes problems).
  # Perhaps revisit in the future? (NDK r9d, 8/7/14)
else()
  set_target_properties(${Casablanca_LIBRARY} PROPERTIES
    SOVERSION ${CPPREST_VERSION_MAJOR}.${CPPREST_VERSION_MINOR})

  install(
    TARGETS ${Casablanca_LIBRARY}
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
    )
endif()

=== Release/samples/BlackJack/BlackJack_Server/CMakeLists.txt ===
if (UNIX)
  add_definitions(-Wno-sign-compare -Wno-enum-compare)
endif()

add_executable(blackjackserver
  BlackJack_Server.cpp
  Dealer.cpp
  stdafx.cpp
  Table.cpp
  )

target_link_libraries(blackjackserver ${Casablanca_LIBRARIES})

=== Release/tests/common/TestRunner/CMakeLists.txt ===
include_directories(${Casablanca_INCLUDE_DIR}
  ../UnitTestpp
  ${Boost_INCLUDE_DIR}
  )

set(TR_SOURCES
  test_runner.cpp
  test_module_loader.cpp
  )

add_definitions(-DDESKTOP_TEST_RUNNER)

if(NOT IOS AND NOT ANDROID)
  if(BUILD_SHARED_LIBS)
    add_executable(test_runner
      test_runner.cpp
      test_module_loader.cpp
      )

    target_link_libraries(test_runner
      ${Boost_FRAMEWORK}
      ${Boost_SYSTEM_LIBRARY}
      ${Boost_FILESYSTEM_LIBRARY}
      ${LIB}unittestpp
      ${CMAKE_DL_LIBS}
      )
  else()
    if (APPLE)
      add_executable(test_runner
        test_runner.cpp
        test_module_loader.cpp
        )

      target_link_libraries(test_runner
        ${Boost_FRAMEWORK}
        ${Boost_SYSTEM_LIBRARY}
        ${Boost_FILESYSTEM_LIBRARY}
        ${LIB}unittestpp
        ${CMAKE_DL_LIBS}
        -Wl,-force_load
        ${LIB}httpclient_test

        -Wl,-force_load
        ${LIB}json_test

        -Wl,-force_load
        ${LIB}uri_test

        -Wl,-force_load
        ${LIB}pplx_test

        -Wl,-force_load
        ${LIB}httplistener_test

        -Wl,-force_load
        ${LIB}streams_test

        -Wl,-force_load
        ${LIB}utils_test
        )
    elseif(UNIX)
      add_executable(test_runner
        test_runner.cpp
        test_module_loader.cpp
        )

      target_link_libraries(test_runner
        ${Boost_FRAMEWORK}
        ${Boost_SYSTEM_LIBRARY}
        ${Boost_FILESYSTEM_LIBRARY}
        ${LIB}unittestpp
        ${CMAKE_DL_LIBS}
        -Wl,--whole-archive
        ${LIB}httpclient_test
        ${LIB}json_test
        ${LIB}uri_test
        ${LIB}pplx_test
        ${LIB}httplistener_test
        ${LIB}streams_test
        ${LIB}utils_test
        -Wl,--no-whole-archive
        )
    else()
      # In order to achieve --whole-archive on windows, we link all the test files into the test_runner directly
      # This means that the tests themselves must be created as "OBJECT" libraries
      add_executable(test_runner
        test_runner.cpp
        test_module_loader.cpp
        $<TARGET_OBJECTS:${LIB}httpclient_test>
        $<TARGET_OBJECTS:${LIB}json_test>
        $<TARGET_OBJECTS:${LIB}uri_test>
        $<TARGET_OBJECTS:${LIB}pplx_test>
        $<TARGET_OBJECTS:${LIB}httplistener_test>
        $<TARGET_OBJECTS:${LIB}streams_test>
        $<TARGET_OBJECTS:${LIB}utils_test>
        )
      target_link_libraries(test_runner
        ${LIB}unittestpp
        ${CMAKE_DL_LIBS}
        )
    endif()
  endif()
endif()

=== Release/tests/functional/http/client/CMakeLists.txt ===
include_directories(
  ../utilities/include
  ../utilities/testlistener/include
  ${OPENSSL_INCLUDE_DIR}
)

set(SOURCES
  authentication_tests.cpp
  building_request_tests.cpp
  client_construction.cpp
  connections_and_errors.cpp
  header_tests.cpp
  http_client_tests.cpp
  http_methods_tests.cpp
  multiple_requests.cpp
  oauth1_tests.cpp
  oauth2_tests.cpp
  outside_tests.cpp
  pipeline_stage_tests.cpp
  progress_handler_tests.cpp
  proxy_tests.cpp
  request_helper_tests.cpp
  request_stream_tests.cpp
  request_uri_tests.cpp
  response_extract_tests.cpp
  response_stream_tests.cpp
  status_code_reason_phrase_tests.cpp
  to_string_tests.cpp
  http_client_fuzz_tests.cpp
)

add_casablanca_test(${LIB}httpclient_test SOURCES)

=== Release/tests/functional/websockets/client/CMakeLists.txt ===
include_directories(../utilities)

set(SOURCES
  authentication_tests.cpp
  client_construction.cpp
  close_tests.cpp
  error_tests.cpp
  receive_msg_tests.cpp
  send_msg_tests.cpp
)

add_casablanca_test(${LIB}websocketclient_test SOURCES)
target_link_libraries(${LIB}websocketclient_test ${LIB}websockettest_utilities)

=== Release/tests/functional/websockets/utilities/CMakeLists.txt ===
include_directories(include)

if(WIN32)
  add_definitions(-DWEBSOCKETTESTUTILITY_EXPORTS)
endif()

set(SOURCES
  test_websocket_server.cpp
)

add_library(${LIB}websockettest_utilities ${SOURCES})
target_link_libraries(${LIB}websockettest_utilities
  ${LIB}unittestpp
  ${LIB}common_utilities
  ${BOOST_LIBRARIES}
  ${Casablanca_LIBRARIES}
)

=== debian/changelog ===
casablanca (2.6.0-5) unstable; urgency=medium

  * Rebuild against websocketpp 0.6.0-1

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 07 Aug 2015 09:50:37 +0200

casablanca (2.6.0-4) unstable; urgency=medium

  * d/p/disable-outside-tests.patch:
    - Disable some more tests because they require an active internet
      connection.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 04 Aug 2015 15:15:27 +0200

casablanca (2.6.0-3) unstable; urgency=medium

  * Upload to unstable.
    - drop force of gcc-5, now it is the default there.
  * Update my uid.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 31 Jul 2015 13:08:42 +0200

casablanca (2.6.0-2) experimental; urgency=medium

  * enable patches accepted upstream:
    - d/p/fix-build-failures.patch
    - d/p/fix-cdecl.patch
    - d/p/remove-double-includes.patch
  * add patch to fix an arm64 build failure:
    - d/p/fix-failure.patch
  * enable patch to address a kfreebsd-i386 build failure:
    - d/p/kfreebsd-i386-fix.patch

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Thu, 04 Jun 2015 20:43:00 +0200

casablanca (2.6.0-1) experimental; urgency=low

  * New upstream release bump SONAME to 2.6, patch refresh.
  * Add some commented patches:
    - d/p/fix-build-failures.patch: tweak to remove also ch variable
    - d/p/fix-cdecl.patch: fix cdecl and __cdecl usage, this
      should hopefully fix many build failures.
    - d/p/remove-double-includes.patch: remove some double inclusions
      in cmake files (cosmetic patch).
    - d/p/kfreebsd-i386-fix.patch: hopefully fix the kfreebsd-i386 build issue.
      unfortunately I do not have any kfreebsd-i386 2.5 build log, so I'll
      enable and submit it upstream for review if the build still fails there.
  * d/p/disable-outside-tests.patch: re-enable some tests not failing anymore.
  * d/p/use-system-websocketpp.patch: find websocketpp with cmake modules,
    rather than just including it, to easy upstream patch forwarding.
  * Remove d/p/do-not-write-timestamps-in-documentation: upstream
  * d/control: remove locales-all, locales-pack-fr-base and libboost-locale-dev,
    code removed upstream.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Tue, 02 Jun 2015 18:34:53 +0200

casablanca (2.5.0-2) experimental; urgency=medium

  [ Edmund Grimley Evans ]
  * d/p/fix-build-failures.patch
    - try to fix the various build failures on #769969

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Mon, 01 Jun 2015 12:19:22 +0200

casablanca (2.5.0-1) experimental; urgency=medium

  [ Mattia Rizzolo ]
  * Add a patch to have Doxygen not write timestamps in the generated
    documentation to allow package builds to be reproducible.

  [ Gianfranco Costamagna ]
  * Use g++-5 to build, because of bug #784655.
  * New upstream release, bump SONAME to 2.5.
  * Patch refresh.
  * Add locales-all (Debian) | language-pack-fr-base (Ubuntu)
    to correctly pick up locale files (fix testuite failures)
    ref: https://casablanca.codeplex.com/workitem/354
  * Update disable-outside-tests.patch with another test requiring
    internet connection.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 06 May 2015 14:46:43 +0200

=== debian/control ===
Source: casablanca
Section: libs
Priority: extra
Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: cmake,
               debhelper (>=9),
               libboost-chrono-dev,
               libboost-filesystem-dev,
               libboost-random-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libssl-dev,
               libwebsocketpp-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.6
Homepage: https://casablanca.codeplex.com/
Vcs-Git: git://anonscm.debian.org/collab-maint/casablanca.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/casablanca.git

Package: libcpprest2.6
Provides: libcpprest
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Shared library for Casablanca
 The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
 client-server communication in native code using a modern asynchronous C++ API
 design. This project allows C++ developers to take advantage of the radical
 shift in software architecture that cloud computing represents.
  * Support for accessing REST services from native code on Linux, Windows
    Vista, Windows 7, and Windows 8 by providing asynchronous C++ bindings
    to HTTP, JSON, and URIs
  * Implementation of Asynchronous Streams and Stream Buffers
  * A consistent and powerful model for composing asynchronous operations based
    on C++ 11 features
  * A set of samples and reference documentation
  * New experimental features such as HTTP Listener library and support for
  Windows Phone 8 and Windows XP.
 .
 This package contains the library files.

Package: libcpprest-dev
Section: libdevel
Architecture: any
Depends: libcpprest2.6 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Development files for Casablanca
 The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
 client-server communication in native code using a modern asynchronous C++ API
 design. This project allows C++ developers to take advantage of the radical
 shift in software architecture that cloud computing represents.
  * Support for accessing REST services from native code on Linux, Windows
    Vista, Windows 7, and Windows 8 by providing asynchronous C++ bindings
    to HTTP, JSON, and URIs
  * Implementation of Asynchronous Streams and Stream Buffers
  * A consistent and powerful model for composing asynchronous operations based
    on C++ 11 features
  * A set of samples and reference documentation
  * New experimental features such as HTTP Listener library and support for
  Windows Phone 8 and Windows XP.
 .
 This package contains header files that are needed to develop and
 compile applications which utilizes the Casablanca framework.

Package: libcpprest-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Reference manual for Casablanca
 The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
 client-server communication in native code using a modern asynchronous C++ API
 design. This project allows C++ developers to take advantage of the radical
 shift in software architecture that cloud computing represents.
  * Support for accessing REST services from native code on Linux, Windows
    Vista, Windows 7, and Windows 8 by providing asynchronous C++ bindings
    to HTTP, JSON, and URIs
  * Implementation of Asynchronous Streams and Stream Buffers
  * A consistent and powerful model for composing asynchronous operations based
    on C++ 11 features
  * A set of samples and reference documentation
  * New experimental features such as HTTP Listener library and support for
  Windows Phone 8 and Windows XP.
 .
 This package contains the common documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SONAME := $(shell dpkg-parsechangelog -SVersion| cut -d ":" -f 2 |cut -d "-" -f 1 |cut -d "." -f 1,2)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
%:
	dh $@ --parallel --sourcedirectory=Release

override_dh_auto_clean:
	dh_auto_clean
	rm -rf html latex

override_dh_auto_build-indep:
	doxygen Release/public_apis_doxyfile

override_dh_install-indep:
	dh_install -plibcpprest-doc html/* usr/share/doc/libcpprest-doc/html

override_dh_install:
	dh_install -plibcpprest-dev Release/include                  usr/
	dh_install -plibcpprest-dev obj-*/Binaries/libcpprest.so     usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install -plibcpprest$(SONAME) obj-*/Binaries/libcpprest.so.$(SONAME) usr/lib/$(DEB_HOST_MULTIARCH)

## casablanca 2.7.0

=== Release/CMakeLists.txt ===
--- 
+++ 
@@ -165,7 +165,20 @@
 
 # These settings can be used by the test targets
 set(Casablanca_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
-set(Casablanca_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include ${Boost_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/libs/websocketpp)
+
+find_path(WEBSOCKETPP_CONFIG websocketpp-config.cmake
+                       HINTS /usr/lib/cmake/websocketpp)
+find_path(WEBSOCKETPP_CONFIG_VERSION websocketpp-configVersion.cmake
+                       HINTS /usr/lib/cmake/websocketpp)
+if(WEBSOCKETPP_CONFIG AND WEBSOCKETPP_CONFIG_VERSION)
+  include(${WEBSOCKETPP_CONFIG}/websocketpp-config.cmake)
+  include(${WEBSOCKETPP_CONFIG}/websocketpp-configVersion.cmake)
+  message("-- Found websocketpp version " ${PACKAGE_VERSION} " on system")
+  set(Casablanca_INCLUDE_DIRS ${Casablanca_INCLUDE_DIR} ${Boost_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR} ${WEBSOCKETPP_INCLUDE_DIR})
+else(WEBSOCKETPP_CONFIG AND WEBSOCKETPP_CONFIG_VERSION)
+  set(Casablanca_INCLUDE_DIRS ${Casablanca_INCLUDE_DIR} ${Boost_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/libs/websocketpp)
+  message("-- websocketpp not found, using the embedded version")
+endif(WEBSOCKETPP_CONFIG AND WEBSOCKETPP_CONFIG_VERSION)
 
 set(Casablanca_LIBRARY ${LIB}cpprest)
 set(Casablanca_LIBRARIES ${Casablanca_LIBRARY} ${Boost_LIBRARIES} ${Boost_FRAMEWORK})

=== Release/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-include_directories(../include pch ${Boost_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR})
+include_directories(pch ${OPENSSL_INCLUDE_DIR})
 
 set(SOURCES_COMMON
   http/client/http_client_msg.cpp
@@ -92,7 +92,7 @@
 
 # Portions specific to cpprest binary versioning.
 set (CPPREST_VERSION_MAJOR 2)
-set (CPPREST_VERSION_MINOR 6)
+set (CPPREST_VERSION_MINOR 7)
 set (CPPREST_VERSION_REVISION 0)
 
 if(WIN32)

=== Release/tests/common/TestRunner/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,4 @@
-include_directories(${Casablanca_INCLUDE_DIR}
-  ../UnitTestpp
-  ${Boost_INCLUDE_DIR}
-  )
+include_directories(${Casablanca_INCLUDE_DIRS})
 
 set(TR_SOURCES
   test_runner.cpp

=== debian/changelog ===
casablanca (2.7.0-4) unstable; urgency=medium

  * Disable some more tests, requiring local ports
    not always available on buildd machines
  * Update homepage field

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 27 Nov 2015 10:49:57 +0100

casablanca (2.7.0-3) unstable; urgency=medium

  * Disable tests were timeouts are encountered, some archs
    are too slow for them.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 26 Nov 2015 15:28:20 +0100

casablanca (2.7.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 26 Nov 2015 12:32:07 +0100

casablanca (2.7.0-1) experimental; urgency=medium

  * New upstream release, bump SONAME.
  * Drop all patches merged upstream.
  * Set priority optional.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 25 Nov 2015 09:40:05 +0100

casablanca (2.6.0-7) unstable; urgency=medium

  * Fix arch:all build

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 19 Oct 2015 18:48:07 +0200

casablanca (2.6.0-6) unstable; urgency=medium

  * Add finally a watch file, thanks to the move to github
    - Drop README.source

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Oct 2015 15:12:24 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: casablanca
 Section: libs
-Priority: extra
+Priority: optional
 Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
 Build-Depends: cmake,
                debhelper (>=9),
@@ -14,11 +14,11 @@
                libwebsocketpp-dev
 Build-Depends-Indep: doxygen
 Standards-Version: 3.9.6
-Homepage: https://casablanca.codeplex.com/
+Homepage: https://github.com/Microsoft/cpprestsdk
 Vcs-Git: git://anonscm.debian.org/collab-maint/casablanca.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/casablanca.git
 
-Package: libcpprest2.6
+Package: libcpprest2.7
 Provides: libcpprest
 Architecture: any
 Multi-Arch: same
@@ -44,7 +44,7 @@
 Package: libcpprest-dev
 Section: libdevel
 Architecture: any
-Depends: libcpprest2.6 (= ${binary:Version}),
+Depends: libcpprest2.7 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: Development files for Casablanca

=== debian/watch ===
version=3
opts=dversionmangle=s/(\+|\.)dfsg$// \
        https://github.com/Microsoft/cpprestsdk/tags .*/v-?(\d\S*)\.tar\.gz
